#include "stdafx.h"
#include "NeMessenger.h"
#include "MemoRecvAttachWnd.h"
#include "AtatchDownload.h"
#include "NeMessengerDlg.h"

#define BTN_TEXT_COLOR RGB(94, 95, 109)
IMPLEMENT_DYNAMIC(CMemoRecvAttachWnd, CWnd)

CMemoRecvAttachWnd::CMemoRecvAttachWnd()
{
	// BG
	m_pImgBG = NULL;
	m_crBG = DEF_MEMORECV_ATTACH_BG_COLOR;
	m_crOutline = DEF_MEMORECV_ATTACH_BGOUTLINE_COLOR;

	// dimension
	m_rtWnd.SetRectEmpty();
	m_rtTitle.SetRectEmpty();
	m_szTitle = CSize(0, 0);
	m_rtFileList.SetRectEmpty();
	m_rtCheckOpenFolder.SetRectEmpty();

	m_strTitle = _T("");

	// attribute
	m_nFontHeightTitle = DEF_MEMORECV_ATTACH_TITLE_FONT_HEIGHT;
	m_crTitle = DEF_MEMORECV_ATTACH_TITLE_FONT_COLOR;
	m_fontStyleTitle = DEF_MEMORECV_ATTACH_TITLE_FONT_STYLE;

	m_bSelFolderDlgIsActive = false;
	m_hBrushWhite = CreateSolidBrush(RGB(255,255,255));
    m_wszFontName[0] = NULL;
    m_nFontHeight = DEF_MEMORECV_ATTACH_TITLE_FONT_HEIGHT;
    m_fontStyle = FontStyleRegular;

}

CMemoRecvAttachWnd::~CMemoRecvAttachWnd()
{
	DeleteObject(m_hBrushWhite);
}

BEGIN_MESSAGE_MAP(CMemoRecvAttachWnd, CWnd)
	ON_WM_CREATE()
	ON_WM_DESTROY()
	ON_WM_ERASEBKGND()
	ON_WM_PAINT()
	ON_WM_SIZE()
	ON_BN_CLICKED(ID_MEMO_RECV_SAVEALL_BTN, OnBtnFileSaveAll)
	ON_BN_CLICKED(ID_MEMO_RECV_SELECT_FOLDER, OnBtnSelectFolder)
	ON_BN_CLICKED(ID_MEMO_RECV_OPEN_FOLDER_CHECKBOX, OnBtnCheckOpenFolder)
	ON_WM_CTLCOLOR()
	ON_MESSAGE(WM_FOLDER_SELECTED, OnFolderSelected)
END_MESSAGE_MAP()

void CMemoRecvAttachWnd::SetImgBGPath(CString strFileName)
{
	CString strImgPath = _T(""), strImgDir = _T("");

	strImgDir = GetAppImgDir();

	if (strFileName.IsEmpty())
		return;
	strImgPath.Format(_T("%s\\%s"), strImgDir, strFileName);

	m_pImgBG = new Image(strImgPath);
}

void CMemoRecvAttachWnd::SetFontConfig(WCHAR* wszFontName, REAL nFontHeight, FontStyle style, Color crText)
{
	_tcscpy_s(m_wszFontName, wszFontName);
	m_nFontHeight = nFontHeight;
	m_fontStyle = style;

	m_crText = crText;
}

void CMemoRecvAttachWnd::SetTitle(CString strTitle)
{
	m_strTitle = strTitle;

	RedrawWindow(&m_rtTitle, NULL, RDW_INVALIDATE | RDW_UPDATENOW | RDW_ERASE | RDW_ALLCHILDREN);
}

int	CMemoRecvAttachWnd::GetFileItemCount()
{
	if (m_listFileAttach.GetSafeHwnd())
		return m_listFileAttach.GetFileItemCount();

	return 0;
}

CString	CMemoRecvAttachWnd::GetFileItemDownloadURL(int nIdx)
{
	if (m_listFileAttach.GetSafeHwnd())
		return m_listFileAttach.GetFileItemDownloadURL(nIdx);

	return _T("");
}

void CMemoRecvAttachWnd::AddFileItem(CString strPath, CString strName, ULONGLONG dwFileSize)
{
	if (m_listFileAttach.GetSafeHwnd())
		m_listFileAttach.AddFileItem(strPath, strName, dwFileSize);
}

int CMemoRecvAttachWnd::OnCreate(LPCREATESTRUCT lpCreateStruct)
{
	if (CWnd::OnCreate(lpCreateStruct) == -1)
		return -1;

	// Save all button
	if (!m_btnFileSaveAll.Create(_T(""), WS_CHILD | WS_VISIBLE | BS_OWNERDRAW, CRect(0,0,0,0), this, ID_MEMO_RECV_SAVEALL_BTN))
		return -1;

	m_btnFileSaveAll.SetBtnBitmapFile(GetAppImgFile(_T("MemoRecv_FileSave_Btn.bmp")), RGB(0, 0, 0));
	m_btnFileSaveAll.SetBmpText(LoadStringFromResource(IDS_STRING451));
	m_btnFileSaveAll.SetBmpFont(&g_ftDefault9PT);
	m_btnFileSaveAll.SetBmpFontColor(BTN_TEXT_COLOR);
	m_btnFileSaveAll.EnableHandCursor(TRUE);
	//  ٿε   ư
	if (!m_btnSelectFolder.Create(_T(""), WS_CHILD | WS_VISIBLE | BS_OWNERDRAW, CRect(0,0,0,0), this, ID_MEMO_RECV_SELECT_FOLDER))
		return -1;

	m_btnSelectFolder.SetBtnBitmapFile(GetAppImgFile(_T("btn_05_find.bmp")),RGB(0,0,0));
	m_btnSelectFolder.EnableHandCursor(TRUE);
	m_btnFileSaveAll.SetBmpFontColor(BTN_TEXT_COLOR);
	//  ٿα  ǥ Ʈ ڽ
	if (!m_editDownloadFolderPath.Create(WS_CHILD | WS_VISIBLE | WS_CLIPCHILDREN | ES_AUTOHSCROLL, CRect(0,0,0,0), this, ID_MEMO_RECV_SELECT_FOLDER_EDITBOX))
		return -1;

	m_editDownloadFolderPath.SetFont(&g_ftDefault9PT);
	m_editDownloadFolderPath.SetWindowText(GET_CONFIG()->GetRecvFolder());
	//   üũڽ
	if (!m_checkOpenFolder.Create(_T(""), WS_CHILD | WS_VISIBLE | WS_CLIPCHILDREN | BS_CHECKBOX | BS_OWNERDRAW, CRect(0,0,0,0), this, ID_MEMO_RECV_OPEN_FOLDER_CHECKBOX))
		return -1;

	m_checkOpenFolder.SetBitmapFile(GetAppImgFile(_T("checkbox.bmp")),RGB(0,0,0));
	m_checkOpenFolder.SetCheck(GET_CONFIG()->IsOpenFolderAfterDownload());

	CString strTmpClassName = _T("");
	strTmpClassName.Format(_T("Ntalk_MemoRecv_FileList"));
	RegisterWindowClass(strTmpClassName);

	// ÷ Ʈ
	if (!m_listFileAttach.Create(strTmpClassName, _T("Ntalk_MemoRecv_FileList"), WS_CHILD | WS_VISIBLE | WS_CLIPCHILDREN, CRect(0,0,0,0), this, ID_MEMO_RECV_ATTACH_LIST))
		return -1;

	m_listFileAttach.SetImgFilePath(_T("MemoRecv_Attach_File.png"));
	m_listFileAttach.SetImgDownloadPath(_T("MemoRecv_Download_File.png"));	
	m_listFileAttach.SetFontConfig(g_defaultFontFaceName, 8.5, FontStyleRegular, Color(255, 102, 102, 102));

	return 0;
}

void CMemoRecvAttachWnd::OnDestroy()
{
	if (m_pImgBG)
	{
		delete m_pImgBG;
		m_pImgBG = NULL;
	}

	if (m_btnSelectFolder.GetSafeHwnd())
		m_btnSelectFolder.DestroyWindow();

	if (m_btnFileSaveAll.GetSafeHwnd())
		m_btnFileSaveAll.DestroyWindow();

	if (m_listFileAttach.GetSafeHwnd())
		m_listFileAttach.DestroyWindow();

	if (m_editDownloadFolderPath.GetSafeHwnd())
		m_editDownloadFolderPath.DestroyWindow();

	if (m_checkOpenFolder.GetSafeHwnd())
		m_checkOpenFolder.DestroyWindow();

	CWnd::OnDestroy();
}

BOOL CMemoRecvAttachWnd::OnEraseBkgnd(CDC* pDC)
{
	//CRect rcClient;
	//GetClientRect(rcClient);
	//pDC->FillSolidRect(rcClient,RGB(255,255,255));

    CRect rtEdit(0, 0, 0, 0);
	m_editDownloadFolderPath.GetWindowRect(&rtEdit);
	CPen penEditBox;
	penEditBox.CreatePen(PS_SOLID, 1, RGB(198,202,205));
	CPen *pOldpen = pDC->SelectObject(&penEditBox);
	ScreenToClient(&rtEdit);
	rtEdit.InflateRect(1, 1);
	pDC->Rectangle(rtEdit);
	pDC->SelectObject(pOldpen);
	/*	graph.DrawRectangle(&Pen(Color(255,200,200,200), 1), rtEdit.left, rtEdit.top, rtEdit.Width(), rtEdit.Height());*/

	return TRUE;
}

void CMemoRecvAttachWnd::OnPaint()
{
	CPaintDC dc(this); // device context for painting

	PAINTSTRUCT ps = dc.m_ps;
	int psWidth = ps.rcPaint.right - ps.rcPaint.left;
	int psHeight = ps.rcPaint.bottom - ps.rcPaint.top;

	int nPX = ps.rcPaint.left;
	int nPY = ps.rcPaint.top;

	CRect rtPS(nPX, nPY, nPX + psWidth, nPY + psHeight);

	CRect rt(0, 0, 0, 0);
	GetClientRect(&rt);
	int nWndWidth = rt.Width();
	int nWndHeight = rt.Height();

	HDC hdc = dc.GetSafeHdc();

	HDC	hdcMemory = CreateCompatibleDC(hdc);

	if (hdcMemory == NULL)
		return;

	HBITMAP hbmpMem = CreateCompatibleBitmap(hdc, psWidth, psHeight);

	HGDIOBJ hbmpOld = ::SelectObject(hdcMemory,  hbmpMem);

	Graphics graph(hdcMemory);

	if (hbmpMem)
	{
		graph.SetSmoothingMode(SmoothingModeAntiAlias);
		graph.SetInterpolationMode(InterpolationModeHighQualityBicubic);
		graph.SetPageUnit(UnitPixel);

		ImageAttributes ImgAttr;

		SolidBrush brushBG(m_crBG);
		Pen penBG(m_crOutline, 1);
		int nSX = 0, nSY = 0, nCX = 0, nCY = 0, nEX = 0, nEY = 0;
		if (m_pImgBG)
			DrawImageToStretchHorz(&graph, m_pImgBG, &rtPS, &m_rtWnd, m_crBG, &ImgAttr);
		else
		{
			nSX = m_rtWnd.left - rtPS.left;
			nSY = m_rtWnd.top - rtPS.top;
			nCX = m_rtWnd.Width();
			nCY = m_rtWnd.Height();
			graph.FillRectangle(&brushBG, nSX - 1, nSY - 1, nCX + 1, nCY - 1);
			graph.DrawRectangle(&penBG, nSX - 1, nSY, nCX + 1, nCY - 1);
		}


		if (!m_strTitle.IsEmpty())
		{
			DrawTextToDest2(&graph,
				m_strTitle, &rtPS, &m_rtTitle,
				m_wszFontName, m_nFontHeightTitle,
				StringAlignmentNear,
				m_fontStyleTitle,
				m_crTitle);
		}

		// " " ڿ
		CRect rtOpenFolder(m_rtTitle);
		rtOpenFolder.left = m_rtCheckOpenFolder.right + 2;
		rtOpenFolder.right = rtOpenFolder.left + 120;
		DrawTextToDest2(&graph, LoadStringFromResource(IDS_STRING386), &rtPS, &rtOpenFolder, m_wszFontName, 8, StringAlignmentNear, FontStyleRegular, m_crTitle);

		BitBlt(dc.GetSafeHdc(), nPX, nPY, psWidth, psHeight, hdcMemory, 0, 0, SRCCOPY);

		CRect rtEdit(0, 0, 0, 0);
		m_editDownloadFolderPath.GetWindowRect(&rtEdit);
		CPen penEditBox;
		penEditBox.CreatePen(PS_SOLID, 1, RGB(198,202,205));
		CPen *pOldpen = dc.SelectObject(&penEditBox);
		ScreenToClient(&rtEdit);
		rtEdit.InflateRect(1, 1, 2, 2);
		dc.Rectangle(rtEdit);
		dc.SelectObject(pOldpen);

		::SelectObject(hdcMemory, hbmpOld);
		::DeleteObject(hbmpMem);
	}

	::DeleteDC(hdcMemory);
}

void CMemoRecvAttachWnd::OnSize(UINT nType, int cx, int cy)
{
	CWnd::OnSize(nType, cx, cy);

	m_rtWnd.SetRect(0, 0, cx, cy);

	int nSX = 0, nSY = 0, nCX = 0, nCY = 0, nEX = 0, nEY = 0;

	nSX = DEF_MEMORECV_TITLE_POS_LEFT_X;
	nSY = DEF_MEMORECV_TITLE_POS_TOP_Y;
	nCX = cx;

	if (!m_strTitle.IsEmpty() && m_szTitle.cx == 0)
	{
		CRect rtTitle(0, 0, cx, 1000);
		RecalcTextRect(this, m_strTitle, m_wszFontName, m_nFontHeightTitle, m_fontStyleTitle, rtTitle, m_szTitle);
	}
	nCX = m_szTitle.cx + 5;
	nCY = m_szTitle.cy;
	m_rtTitle.SetRect(nSX, nSY, nSX + nCX, nSY + nCY);

	if (m_btnFileSaveAll.GetSafeHwnd())
	{
		nCX = m_btnFileSaveAll.GetImgWidth();
		nCY = m_btnFileSaveAll.GetImgHeight();
		nSX = m_rtWnd.right - DEF_MEMORECV_FILESAVE_POS_RIGHT_X - nCX;
		nSY = DEF_MEMORECV_FILESAVE_POS_TOP_Y;
		CRect rtBtnFileSaveAll(nSX, nSY, nSX + nCX, nSY + nCY);

		m_btnFileSaveAll.MoveWindow(&rtBtnFileSaveAll);
	}

	// ٿε  Ʈڽ  ư
	if (m_editDownloadFolderPath.GetSafeHwnd() && m_btnSelectFolder.GetSafeHwnd() && m_checkOpenFolder.GetSafeHwnd())
	{
		CRect rtEdit(0, 0, 0, 0);
		CRect rtBtn(0, 0, 0, 0);

		// Editbox
		rtEdit.left = m_rtTitle.right + DEF_MEMORECV_TITLE_POS_LEFT_X;
		rtEdit.top = DEF_MEMORECV_FILESAVE_POS_TOP_Y;
		rtEdit.right = rtEdit.left + DEF_MEMORECV_FILELIST_EDIT_WIDTH;
		rtEdit.bottom = rtEdit.top + m_btnSelectFolder.GetImgHeight();
		rtBtn = rtEdit;

		rtEdit.DeflateRect(1,1,2,2);	// ܰ  ׷ֱ  1ȼ ۰  ´.
		m_editDownloadFolderPath.MoveWindow(&rtEdit);

		// Button
		rtBtn.left = rtBtn.right;
		rtBtn.right = rtBtn.left + m_btnSelectFolder.GetImgWidth();
		m_btnSelectFolder.MoveWindow(&rtBtn);

		// Checkbox
		m_rtCheckOpenFolder.left = rtBtn.right + 10;
		m_rtCheckOpenFolder.right = m_rtCheckOpenFolder.left + 11;
		m_rtCheckOpenFolder.top = 13;
		m_rtCheckOpenFolder.bottom = m_rtCheckOpenFolder.top + 11;

		m_checkOpenFolder.MoveWindow(&m_rtCheckOpenFolder);


	}

	if (m_listFileAttach.GetSafeHwnd())
	{
		nSX = m_rtWnd.left;
		nSY = DEF_MEMORECV_FILELIST_POS_TOP_Y;
		nCX = cx;
		nCY = cy - DEF_MEMORECV_FILELIST_POS_TOP_Y;

		m_rtFileList.SetRect(nSX, nSY, nSX + nCX, nSY + nCY);
		m_listFileAttach.MoveWindow(&m_rtFileList);
	}
}

unsigned int __stdcall SelectFolderThread( LPVOID pArg )
{
	SELFOLDER_REQ_PARA *pPara = (SELFOLDER_REQ_PARA *)pArg;

	TCHAR szPath[MAX_PATH + 1] = {0,};
	TCHAR szTitle[MAX_PATH + 1] = {0,};
	_tcscpy_s(szTitle, _countof(szTitle), LoadStringFromResource(IDS_STRING423));

	BROWSEINFO BrowseInfo;
	::ZeroMemory(&BrowseInfo,sizeof(BrowseInfo));

	BrowseInfo.hwndOwner = NULL;
	BrowseInfo.pidlRoot = NULL;
	BrowseInfo.pszDisplayName = szPath;		 // Return display name of item selected.
	BrowseInfo.lpszTitle = szTitle;
	BrowseInfo.ulFlags = BIF_NEWDIALOGSTYLE; // Flags that control the return stuff
	BrowseInfo.lParam = (LPARAM)(LPCTSTR)pPara->strCurPath;
	BrowseInfo.lpfn = ((CMemoRecvAttachWnd*)pPara->pWnd)->SHBrowseCallback;

	CString strPath;
	LPITEMIDLIST lpItemIdList = SHBrowseForFolder(&BrowseInfo);
	if (lpItemIdList)
		SHGetPathFromIDList(lpItemIdList,strPath.GetBuffer(1024));
	else
		strPath = pPara->strCurPath;

	pPara->pWnd->SendMessage(WM_FOLDER_SELECTED, (WPARAM)&strPath, NULL);
	strPath.ReleaseBuffer();

	delete pPara;

	_endthreadex(0);
	return 1;
}

LRESULT CMemoRecvAttachWnd::OnFolderSelected( WPARAM wParam, LPARAM lParam )
{
	CString* pStrFolderPath = (CString*)wParam;
	CString strFolderPath(*pStrFolderPath);

	if (this->GetSafeHwnd() && ::IsWindow(this->m_hWnd) /*&& FALSE == strFolderPath.IsEmpty()*/ )
	{
		m_editDownloadFolderPath.SetWindowText(strFolderPath);
		GET_CONFIG()->SetRecvFolder(strFolderPath);
	}

	m_bSelFolderDlgIsActive = false;

	return 0L;
}

void CMemoRecvAttachWnd::OnBtnSelectFolder()
{
	if( m_bSelFolderDlgIsActive )
		return;

	m_bSelFolderDlgIsActive = true;
	
	SELFOLDER_REQ_PARA *pPara = new SELFOLDER_REQ_PARA;
	pPara->pWnd = this;
	m_editDownloadFolderPath.GetWindowText(pPara->strCurPath);

	HANDLE hSelectFolderThread = (HANDLE)_beginthreadex(NULL, 0, SelectFolderThread, (LPVOID)pPara, 0, NULL);
}

void CMemoRecvAttachWnd::OnBtnCheckOpenFolder()
{
	GET_CONFIG()->SetOpenFolderAfterDownload((BOOL)m_checkOpenFolder.GetCheck());
}

int CALLBACK CMemoRecvAttachWnd::SHBrowseCallback(HWND hwnd, UINT uMsg, LPARAM lParam, LPARAM lpData)
{
	TCHAR szPath[MAX_PATH] = {0};
	switch(uMsg)
	{
	case BFFM_INITIALIZED:
		::SendMessage(hwnd, BFFM_SETSELECTION, TRUE, lpData);
		break;

	case BFFM_SELCHANGED:
		SHGetPathFromIDList((LPCITEMIDLIST) lParam, szPath);

		if(_tcscmp(szPath, _T("")) == 0)
			::SendMessage(hwnd, BFFM_ENABLEOK, 0, 0);
		else
			::SendMessage(hwnd, BFFM_ENABLEOK, 0, 1);
		break;
	case BFFM_VALIDATEFAILED:
		break;
	}
	return 0;
}

void CMemoRecvAttachWnd::GetSaveAsPath( CString &folderName )
{
	CString strPath;
	m_editDownloadFolderPath.GetWindowText(strPath);

	TCHAR szPath[MAX_PATH + 1] = {0,};
	TCHAR szTitle[MAX_PATH + 1] = {0,};
	_tcscpy_s(szTitle, _countof(szTitle), LoadStringFromResource(IDS_STRING423));

	BROWSEINFO BrowseInfo;
	::ZeroMemory(&BrowseInfo,sizeof(BrowseInfo));

	BrowseInfo.hwndOwner = this->GetSafeHwnd();
	BrowseInfo.pidlRoot = NULL;
	BrowseInfo.pszDisplayName = szPath;		 // Return display name of item selected.
	BrowseInfo.lpszTitle = szTitle;
	BrowseInfo.ulFlags = BIF_NEWDIALOGSTYLE; // Flags that control the return stuff
	BrowseInfo.lParam = (LPARAM)(LPCTSTR)strPath;
	BrowseInfo.lpfn = SHBrowseCallback;

	LPITEMIDLIST lpItemIdList = SHBrowseForFolder(&BrowseInfo);
	if (lpItemIdList)
	{
		CString strInnerPath;
		SHGetPathFromIDList(lpItemIdList,strInnerPath.GetBuffer(1024));
		strInnerPath.ReleaseBuffer();

		m_editDownloadFolderPath.SetWindowText(strInnerPath);
		folderName = strInnerPath;
	}
}

void CMemoRecvAttachWnd::OnBtnFileSaveAll()
{
	CString strMsg = _T("");

	int nCntItem = m_listFileAttach.GetFileItemCount();
	if (nCntItem <= 0)
	{
		strMsg.LoadString(IDS_STRING235);
		NMessageBox(this, strMsg);
		return;
	}

	CString strFolder = _T("");
	strFolder = GET_CONFIG()->GetRecvFolder();

	CAtatchDownload dlg(this->GetParent());

	ULONGLONG dwFileSize = 0;
	CString strSize = _T(""), strURL = _T(""), strFileName = _T("");
	for (int i = 0; i < nCntItem; i++)
	{
		strFileName = m_listFileAttach.GetFileItemName(i);
		strURL = m_listFileAttach.GetFileItemDownloadURL(i);
		dwFileSize = m_listFileAttach.GetFileItemTotalSize(i);

		strSize.Format(_T("%d"), (INT)dwFileSize);

		dlg.AddDownloadFile(strURL, strFolder, strFileName, strSize);
	}

	dlg.SetOpenFolderAfterDownload(GET_CONFIG()->IsOpenFolderAfterDownload());

    GET_MESSENGER_DLG()->RegisterMfcModalDlg(&dlg);
    int nRet = dlg.DoModal();
    UNREFERENCED_PARAMETER(nRet);
    GET_MESSENGER_DLG()->UnRegisterMfcModalDlg(&dlg);

}

void CMemoRecvAttachWnd::__ResourceLoad(BOOL bInit)
{
	if (bInit == TRUE)
	{
	}
	else
	{
		m_btnFileSaveAll.SetBmpText(LoadStringFromResource(IDS_STRING451));
	}
}

HBRUSH CMemoRecvAttachWnd::OnCtlColor(CDC* pDC, CWnd* pWnd, UINT nCtlColor)
{
	HBRUSH hbr = CWnd::OnCtlColor(pDC, pWnd, nCtlColor);

	if (pWnd->GetDlgCtrlID() == ID_MEMO_RECV_SELECT_FOLDER_EDITBOX)
	{
		pDC->SetBkMode(TRANSPARENT);
		hbr = m_hBrushWhite;
	}

	return hbr;
}

BOOL CMemoRecvAttachWnd::OnCommand(WPARAM wParam, LPARAM lParam)
{
	UINT notificationCode = (UINT)HIWORD(wParam);

	switch (notificationCode)
	{
	case EN_KILLFOCUS:
		{
			CheckFolderPath();
			return TRUE;
		}
		break;
	case EN_SETFOCUS:
		{
		}
		break;
	}

	return CWnd::OnCommand(wParam, lParam);
}

void CMemoRecvAttachWnd::CheckFolderPath()
{
	CString strPath;
	m_editDownloadFolderPath.GetWindowText(strPath);

	if (-1 == _waccess(strPath, 0))
	{
		if (-1 == _wmkdir(strPath))
		{
			NMessageBox(this, LoadStringFromResource(IDS_STRING_CREATE_FOLDER_FAIL));
			return;
		}
	}

	GET_CONFIG()->SetRecvFolder(strPath);
}
